Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mule.config
Class PoolingProfile

    java.lang.Object
      org.mule.config.PoolingProfile

    public class PoolingProfile

extends Object

`PoolingProfile` is a configuration object used to define the object pooling parameters for the service it is associated with.

Field Summary
`static int` | `DEFAULT_MAX_POOL_ACTIVE` Controls the maximum number of Mule components that can be borrowed from a service pool at one time.
`static int` | `DEFAULT_MAX_POOL_IDLE` Controls the maximum number of Mule components that can sit idle in the pool at any time.
`static long` | `DEFAULT_MAX_POOL_WAIT` When the threadPoolExhaustedAction is set to WHEN_EXHAUSTED_WAIT this can specify the maximum milliseconds the pool should block before throwing a NoSuchElementException
`static int` | `DEFAULT_POOL_EXHAUSTED_ACTION` Specifies the behaviour of the Mule component pool when the pool is exhausted: WHEN_EXHAUSTED_FAIL : will throw a NoSuchElementException WHEN_EXHAUSTED_WAIT : will block (invoke Object.wait(long) until a new or idle object is available. WHEN_EXHAUSTED_GROW : will create a new Mule and return it (essentially making maxActive meaningless). If a positive maxWait value is supplied, it will block for at most that many milliseconds, after which a NoSuchElementException will be thrown.
`static int` | `DEFAULT_POOL_INITIALISATION_POLICY` Determines how components in a pool should be initialised.
`static int` | `INITIALISE_ALL` Tells the object pool to initialise all components on startup.
`static int` | `INITIALISE_NONE` Tells the object pool not to initialise any components on startup.
`static int` | `INITIALISE_ONE` Tells the object pool only to initialise one service on startup.
`static Map<String,Integer>` | `POOL_EXHAUSTED_ACTIONS`
`static Map<String,Integer>` | `POOL_INITIALISATION_POLICIES`
`static int` | `WHEN_EXHAUSTED_FAIL`
`static int` | `WHEN_EXHAUSTED_GROW`
`static int` | `WHEN_EXHAUSTED_WAIT`

Constructor Summary
`PoolingProfile()`
`PoolingProfile(int maxActive, int maxIdle, long maxWait, int exhaustedAction, int initialisationPolicy)`
`PoolingProfile(PoolingProfile pp)`

Method Summary
`int` | `getExhaustedAction()`
`int` | `getInitialisationPolicy()`
`int` | `getMaxActive()`
`int` | `getMaxIdle()`
`long` | `getMaxWait()`
`void` | `setExhaustedAction(int exhaustedAction)`
`void` | `setInitialisationPolicy(int policy)`
`void` | `setMaxActive(int maxActive)`
`void` | `setMaxIdle(int maxIdle)`
`void` | `setMaxWait(long maxWait)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### INITIALISE_NONE

    public static final int INITIALISE_NONE

  Tells the object pool not to initialise any components on startup.

  See Also:
    Constant Field Values

### INITIALISE_ONE

    public static final int INITIALISE_ONE

  Tells the object pool only to initialise one service on startup.

  See Also:
    Constant Field Values

### INITIALISE_ALL

    public static final int INITIALISE_ALL

  Tells the object pool to initialise all components on startup.

  See Also:
    Constant Field Values

### WHEN_EXHAUSTED_FAIL

    public static final int WHEN_EXHAUSTED_FAIL

See Also:
  Constant Field Values

### WHEN_EXHAUSTED_WAIT

    public static final int WHEN_EXHAUSTED_WAIT

See Also:
  Constant Field Values

### WHEN_EXHAUSTED_GROW

    public static final int WHEN_EXHAUSTED_GROW

See Also:
  Constant Field Values

### DEFAULT_MAX_POOL_ACTIVE

    public static final int DEFAULT_MAX_POOL_ACTIVE

  Controls the maximum number of Mule components that can be borrowed from a service pool at one time. When non-positive, there is no limit to the number of components that may be active at one time. When maxActive is exceeded, the pool is said to be exhausted. You can specify this value on the descriptor declaration. If none is set this value will be used.

  See Also:
    Constant Field Values

### DEFAULT_MAX_POOL_IDLE

    public static final int DEFAULT_MAX_POOL_IDLE

  Controls the maximum number of Mule components that can sit idle in the pool at any time. When non-positive, there is no limit to the number of Mule components that may be idle at one time. You can specify this value on the descriptor declaration. If none is set this value will be used. If this value is not set then a system default of '5' will be used.

  See Also:
    Constant Field Values

### DEFAULT_MAX_POOL_WAIT

    public static final long DEFAULT_MAX_POOL_WAIT

  When the threadPoolExhaustedAction is set to WHEN_EXHAUSTED_WAIT this can specify the maximum milliseconds the pool should block before throwing a NoSuchElementException

  See Also:
    Constant Field Values

### DEFAULT_POOL_EXHAUSTED_ACTION

    public static final int DEFAULT_POOL_EXHAUSTED_ACTION

  Specifies the behaviour of the Mule component pool when the pool is exhausted:
  - WHEN_EXHAUSTED_FAIL : will throw a NoSuchElementException
  - WHEN_EXHAUSTED_WAIT : will block (invoke Object.wait(long) until a new or idle object is available.
  - WHEN_EXHAUSTED_GROW : will create a new Mule and return it (essentially making maxActive meaningless).
  If a positive maxWait value is supplied, it will block for at most that many milliseconds, after which a NoSuchElementException will be thrown. If maxWait is non-positive, it will block indefinitely.

  See Also:
    Constant Field Values

### DEFAULT_POOL_INITIALISATION_POLICY

    public static final int DEFAULT_POOL_INITIALISATION_POLICY

  Determines how components in a pool should be initialised. The possible values are:
  - INITIALISE_NONE : Will not load any components in the pool on startup
  - INITIALISE_ONE : Will load only the first service in the pool on startup
  - INITIALISE_ALL : Will load all components in the pool on startup

  See Also:
    Constant Field Values

### POOL_EXHAUSTED_ACTIONS

    public static final Map<String,Integer> POOL_EXHAUSTED_ACTIONS

### POOL_INITIALISATION_POLICIES

    public static final Map<String,Integer> POOL_INITIALISATION_POLICIES

Constructor Detail

### PoolingProfile

    public PoolingProfile()

### PoolingProfile

    public PoolingProfile(PoolingProfile pp)

### PoolingProfile

    public PoolingProfile(int maxActive,
                          int maxIdle,
                          long maxWait,
                          int exhaustedAction,
                          int initialisationPolicy)

Method Detail

### getMaxIdle

    public int getMaxIdle()

  Returns:
    max number of Mule components that can be idle in a service

### getMaxActive

    public int getMaxActive()

  Returns:
    max number of Mule components that can be active in a service

### getMaxWait

    public long getMaxWait()

  Returns:
    time in miilisconds to wait for a Mule component to be available in a service when the pool of Mule components is exhausted and the PoolExhaustedAction is set to WHEN_EXHAUSTED_BLOCK

### getExhaustedAction

    public int getExhaustedAction()

  Returns:
    the action when the Mule component pool is exhaused for a service

### getInitialisationPolicy

    public int getInitialisationPolicy()

### setInitialisationPolicy

    public void setInitialisationPolicy(int policy)

### setMaxIdle

    public void setMaxIdle(int maxIdle)

### setMaxActive

    public void setMaxActive(int maxActive)

### setMaxWait

    public void setMaxWait(long maxWait)

### setExhaustedAction

    public void setExhaustedAction(int exhaustedAction)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2010 MuleSoft, Inc.. All Rights Reserved.